//	BeStrip.h

#pragma once

#include "BeModule.h"
#include "Infinitas.h"
#include "PushButton.h"
#include "ShadowColors.h"

enum
{
	STRIP_MODULE_BORDER = 4,
	STRIP_MIN_WIDTH = 20
};

class ModuleFilter : public BMessageFilter
{
	private:
	
		BeModule *module;
		
	public:
	
		ModuleFilter(BeModule *);
		
		filter_result Filter(BMessage *,BHandler **);
};

class ModuleContainer : public PushButton
{
	friend class StripWindow;
	
	private:
	
		BeModule *module;
		image_id addon;
		ShadowColors *colors;
		
		void calcPics();
		
	public:
	
		ModuleContainer(BeModule *,rgb_color,image_id);
		~ModuleContainer();
		
		void AttachedToWindow();
		void FrameMoved(BPoint);
		void FrameResized(float,float);
		void MessageReceived(BMessage *);
		void MouseDown(BPoint);
};

class StripWindow : public Infinitas
{
	private:
	
		const static rgb_color baseColor;
		
		BList *moduleList;
		
		void recalc();
		
	public:
	
		StripWindow(BPoint);
		~StripWindow();
		
		void DispatchMessage(BMessage *,BHandler *);
		void Minimize(bool);
		void Zoom(BPoint,float,float);
				
		long AddModule(BFile *);
};

class StripApplication : public BApplication
{
	private:
	
		enum
		{
			signature = 'Rhye',
			aboutTextResType = 'CSTR',
			aboutTextResID = 0
		};
		
		char *aboutText;
		const static char *backupText;
		const static char *moduleFolderName;
		
	public:
	
		StripApplication();
		
		void AboutRequested();
		void ReadyToRun();
};