//	DesktopColor.cc

#include "DesktopColor.h"

DesktopColor::DesktopColor(BResourceFile *file)
	: BeModule(file)
{
	popup = new ColorPopup(NULL,8);
	icon = BMLoadSmallIcon(resFile,iconResID);
	arrow = BMLoadBitmapRsrc(resFile,arrowResID);
	float width = icon->Bounds().Width()+arrow->Bounds().Width()+4;
	float height = icon->Bounds().Height();
	ResizeTo(width,height);
}

void DesktopColor::Draw(BRect clipRect)
{
	BRect rect = icon->Bounds();
	BMDrawIcon(this,icon,BPoint(0,0),false);
	BPoint arrowPos(3+rect.Width(),(rect.Height()-arrow->Bounds().Height())/2);
	BMDrawIcon(this,arrow,arrowPos,false);
}

void DesktopColor::MessageReceived(BMessage *message)
{
	switch (message->what)
	{
		case BM_CLICKED:
			BPoint offset = ConvertToScreen(BPoint(0,0));
			BRect bounds = Bounds();
			bounds.OffsetBy(offset);
			BMenuItem *item = popup->Go(bounds);
			ColorItem *colorItem = cast_as(item,ColorItem);
			if (colorItem)
				set_desktop_color(colorItem->Color(),true);
	}
}

ulong DesktopColor::ModuleFlags()
{
	return 0;
}

BeModule *CreateModule(BResourceFile *file)
{
	return new DesktopColor(file);
}