//	IconModule.cc

#include "IconModule.h"
#include "BMUtils.h"

IconModule::IconModule(BResourceFile *file)
	: BeModule(file)
{
	smallIcon = BMLoadSmallIcon(resFile,iconResID);
	largeIcon = BMLoadLargeIcon(resFile,iconResID);
	selected = false;
	big = true;
	icon = largeIcon;
	ResizeTo(32,32);
}

void IconModule::Draw(BRect clipRect)
{
	if (big && largeIcon)
		icon = largeIcon;
	else if (!big && smallIcon)
		icon = smallIcon;
	BMDrawIcon(this,icon,BPoint(0,0),selected);
}

void IconModule::MouseDown(BPoint where)
{
	if (icon && BMBitmapHit(icon,where))
	{
		selected = true;
		Invalidate();
	}
}

void IconModule::MessageReceived(BMessage *message)
{
	switch (message->what)
	{
		case B_MOUSE_UP:
			selected = false;
			big = !big;
			if (big)
			{
				icon = largeIcon;
				ResizeTo(32,32);
			}
			else
			{
				icon = smallIcon;
				ResizeTo(16,16);
			}
	}
}

ulong IconModule::ModuleFlags()
{
	return BM_HANDLE_MOUSE;
}

BeModule *CreateModule(BResourceFile *file)
{
	return new IconModule(file);
}